﻿#-------------------------------------------------------------------------------
# Name:          CFPack Stealer 1.01
# Purpose:       Распаковка смайликов Коммфорта из .cfpack-файла
# Compatibility: Commfort 5.30, 5.40
#
# Author:        bomzhe
#
# Created:       04.04.2012
# Copyright:     (c) ru-board 2012
# Licence:       WTFPL
#
# Usage: cfpack_st.py "c:\Users\user\AppData\Roaming\CommFort\Cache\pack.cfpack"
#-------------------------------------------------------------------------------
#!/usr/bin/env python

import struct, os, sys
from time import strftime

ext = {b'\x47\x49': 'gif',
       b'\xff\xd8': 'jpg',
       b'\x89\x50': 'png',
       b'\x42\x4d': 'bmp'}

def main():
    print('\nCFPack Stealer 1.01\n')
    Pack, Cats = {}, []
    path = sys.argv[1]
#   path = r'd:\Progs\CommFort\DefaultSmilies.cfpack'
    if not os.path.exists(path):
        print('Файл '+ path + ' не найден. Работа прекращена.')
        exit()
    with open(path, 'rb') as f:
        server = (os.path.dirname(sys.argv[0]) +
                 '\\' + os.path.basename(path).split('.')[0])
        if not os.path.exists(server):
            os.mkdir(server)
        print(strftime('[%H:%M:%S] Please wait.'))
        size = struct.unpack('<H', f.read(2)) # размер заголовка, нам не нужен
        Pack['width'], Pack['height'], count = struct.unpack('<HHB', f.read(5))
        for c in range(count):
            size = ord(f.read(1))*2 # 2 байта на символ utf16
            Cats.append((f.read(size)).decode('utf-16le')) # запоминаем категории
            Pack[Cats[c]] = []
            if not os.path.exists(server+'\\'+Cats[c]):
                os.mkdir(server+'\\'+Cats[c])
        Pack['count'] = struct.unpack('<H', f.read(2))[0] # число смайлов в паке
        for item in range(Pack['count']):
            f.seek(1, 1) # размер заголовка пропускаем
            cat_cur = ord(f.read(1))
            if cat_cur >= count:
                print('Обнаружена ошибка в структуре файла. Обработка прекращена.')
                exit()
            size = ord(f.read(1))*2
            alias = (f.read(size)).decode('utf-16le')
            f.seek(1, 1) # 0
            size = struct.unpack('<I', f.read(4))[0]
            data = f.read(size)
            with open('{0}\\{1}\\{2:04x}.{3}'.format(server, Cats[cat_cur],
                item, ext.get(data[:2],'')), 'wb') as gif:
                gif.write(data)
            Pack[Cats[cat_cur]].append(('{0}\\{1:04x}.{2}'.format(Cats[cat_cur],
                item, ext.get(data[:2],'')), alias))
#------------------------------ Smilies_serv.txt -------------------------------
    with open(server+'\\Smilies_serv.txt', 'w', encoding='cp1251') as f:
        f.write(strftime('// %m.%d.%Y %H:%M:%S\n'))
        f.write('// Количество смайлов: '+str(Pack['count']))
        f.write('\n// Категории:\n')
        for c in range(count):
            f.write('//\t'+Cats[c]+'\n')
        f.write('\n\nWidth=' + str(Pack['width']))
        f.write('\nHeight=' + str(Pack['height']))
        f.write('\n')
        for c in range(count):
            f.write('\n['+Cats[c]+']\n')
            for item in Pack[Cats[c]]:
                f.write('{0}|"{1}"\n'.format(item[0], item[1]))
    print(strftime('[%H:%M:%S] Done.'))

if __name__ == '__main__':
    main()
